unit personform;
{formular zadavani udaju k vybrane/ nove osobe}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, define;

type
  TFormOsob = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Edit3: TEdit;
    Edit4: TEdit;
    Label7: TLabel;
    ComboBox3: TComboBox;
  private
    FOsoba      : TOsoba;
    FOsoby      : TList;
    function FillStruc : boolean;
    procedure FillForm;
  public
    function Execute(var Osoba : TOsoba; const Osoby:TList) : boolean;
  end;

var
  FormOsob: TFormOsob;

implementation


{$R *.DFM}

{ TTPersonForm }

function TFormOsob.Execute(var Osoba: TOsoba; const Osoby:TList): boolean;
{metoda, ktera vraci spravne vyplneny formular a stav udaju platne/neplatne}
begin
 FOsoba:=Osoba;
 FOsoby:=Osoby;
 FillForm;
 repeat
         ShowModal;
         Result:=ModalResult=mrOK;
 until not Result or FillStruc;
 Release;
end;

procedure TFormOsob.FillForm;
begin
 VypisMuze(FOsoby,ComboBox1);
 VypisZeny(FOsoby,ComboBox2);
 ComboBox1.Items.AddObject('',nil);
 ComboBox2.Items.AddObject('',nil);
 with FOsoba do begin
        Edit1.Text:=Jmeno;
        Edit2.Text:=Prijmeni;
        Edit3.Text:=IntToStr(Narozeni);
        Edit4.Text:=IntToStr(Umrti);
        ComboBox3.ItemIndex:=integer(Pohlavi);
        ComboBox1.ItemIndex:=ComboBox1.Items.IndexOfObject(Otec);
        ComboBox2.ItemIndex:=ComboBox2.Items.IndexOfObject(Matka);
 end;
end;

function TFormOsob.FillStruc : boolean;
begin
 Result:=true;
 with FOsoba do begin
        Jmeno:=Edit1.Text;
        Prijmeni:=Edit2.Text;
        try
         Narozeni:=StrToInt(Edit3.Text);
        except
         Edit3.SetFocus;
         Result:=False;
         exit;
        end;
        try
         Umrti:=StrToInt(Edit4.Text);
        except
         Edit4.SetFocus;
         Result:=False;
         exit;
        end;
        Pohlavi:=TPohlavi(ComboBox3.ItemIndex);        
        if ComboBox1.ItemIndex>=0
                then Otec:=TOsoba(ComboBox1.Items.Objects[ComboBox1.ItemIndex])
                else Otec:=nil;
        if ComboBox2.ItemIndex>=0
                then Matka:=TOsoba(ComboBox2.Items.Objects[ComboBox2.ItemIndex])
                else Matka:=nil
 end;
end;

end.
