unit view;
{formular, ve kterem je zobrazen rodokmen}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, contnrs, define, ComCtrls;

type
  TForm1 = class(TForm)
    TreeView1: TTreeView;
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure TreeView1Collapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
  private
    FList : TObjectList;
    function NajdiPotomka(Osoba : TOsoba) : TOsoba;
  public
    procedure Vykresli(const List : TObjectList);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TForm1 }

function TForm1.NajdiPotomka(Osoba: TOsoba) : TOsoba;
var i : integer;
begin
 Result:=nil;
 for i:=0 to FList.Count-1 do
        with FList[i] as TOsoba do
                if ((Matka=Osoba) or (Otec=Osoba)) and not Vykreslen then begin
                        Vykreslen:=true;
                        Result:=FList[i] as Tosoba;
                        break;
                end;
end;

procedure TForm1.Vykresli(const List: TObjectList);
var i : integer;
    Odsazeni : integer;
begin
 FList:=List;
 Odsazeni:=0;

 for i:=0 to FList.Count-1 do
        with FList[i] as TOsoba do Vykreslen:=false;

 for i:=0 to FList.Count-1 do
        with FList[i] as TOsoba do
                if (Matka=nil) and (Otec=nil) then
        with TreeView1.Items.AddChildObject(nil,Jmeno+' '+Prijmeni+'('+IntToStr(Narozeni)+')',FList[i]) do begin
                HasChildren:=true;
        end;


 Show;
end;

procedure TForm1.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
var Potomek : TOsoba;
    i       : integer;
    Druh    : TOsoba;
    Str     : string;
begin
 Potomek:=NajdiPotomka(TOsoba(Node.Data));
 while Assigned(Potomek) do begin
  str:='';
  Druh:=nil;
  if Potomek.Matka<>TOsoba(Node.Data) then Druh:=Potomek.Matka;
  if Potomek.Otec<>TOsoba(Node.Data) then Druh:=Potomek.Otec;
  if Assigned(Druh) then Str:='+'+Druh.Jmeno+' '+Druh.Prijmeni+'('+IntToStr(Druh.Narozeni)+')-> ';
  with TreeView1.Items.AddChildObject(Node,Str+Potomek.Jmeno+' '+Potomek.Prijmeni+'('+IntToStr(Potomek.Narozeni)+')',Potomek) do
   HasChildren:=true;
  Potomek:=NajdiPotomka(TOsoba(Node.Data));
 end;
 for i:=0 to FList.Count-1 do
        with FList[i] as TOsoba do Vykreslen:=false;
end;

procedure TForm1.TreeView1Collapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
 Node.DeleteChildren;
 Node.HasChildren:=true;
end;

end.
