unit define;
{konstanty potrebne pro cely program}
interface
uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls;

type
 TPohlavi = (Muz,Zena);
 POsoba = ^TOsoba;
 TOsoba = class(TObject)
  Id            : string;
  Jmeno         : string;
  Prijmeni      : string;
  Pohlavi       : TPohlavi;
  Narozeni      : integer;
  Umrti         : integer;
  Matka         : TOsoba;
  Otec          : TOsoba;
  MId           : string;
  Oid           : string;

  Vykreslen     : boolean;
  Pozice        : integer;
  DelkaJm       : integer;
//  Deti          : TList;
 end;



const
 PohlaviText : array[TPohlavi] of string = ('Mu','ena');
 MaxTags = 8;
 VyskaHladiny  = 50;
 TagText : array[0..MaxTags-1] of string =(
  'id','jmeno','prijmeni','pohlavi','narozeni','umrti','matka','otec'
);

const
 Gid    = 0;
 Gjmeno = 1;
 Gprijmeni = 2;
 Gpohlavi  = 3;
 Gnarozeni = 4;
 Gumrti    = 5;
 Gmatka    = 6;
 Gotec     = 7;

procedure VypisZeny(const Osoby : TList; const ListBox: TComboBox);
procedure VypisMuze(const Osoby : TList; const ListBox: TComboBox);
procedure VypisVse(const Osoby : TList; const ListBox: TComboBox);

function GetTagNum(const Tag : widestring) : integer;

implementation


function GetTagNum(const Tag : widestring) : integer;
var i : integer;
begin
 Result:=-1;
 for i:=0 to Maxtags-1 do
        if AnsiSameText(Tag,TagText[i]) then begin
            Result:=i;
            break;
        end;
end;

procedure VypisZeny(const Osoby : TList; const ListBox: TComboBox);
var i : integer;
begin
 ListBox.Clear;
 for i:=0 to Osoby.Count-1 do
        with TOsoba(Osoby[i]) do
        if POhlavi=Zena then begin
                ListBox.Items.AddObject(Jmeno+' '+Prijmeni,Osoby[i]);
        end;
end;

procedure VypisMuze(const Osoby : TList; const ListBox: TComboBox);
var i : integer;
begin
 ListBox.Clear;
 for i:=0 to Osoby.Count-1 do
        with TOsoba(Osoby[i]) do
        if POhlavi=Muz then begin
                ListBox.Items.AddObject(Jmeno+' '+Prijmeni,Osoby[i]);
        end;
end;

procedure VypisVse(const Osoby : TList; const ListBox: TComboBox);
begin
 VypisMuze(Osoby,ListBox);
 VypisZeny(Osoby,ListBox);
end;

end.
